 # :     , .
# :         stroyka-r.ru  
# :           20.10.2007         
# :        Sahi (.)
#==============================================================================================================

require 'sketchup.rb'

class Zerkalocopy_create
  
  def initialize
    @ip = Sketchup::InputPoint.new
    @ip1 = Sketchup::InputPoint.new
    reset
    Sketchup::set_status_text("Specify moving parametres", SB_PROMPT)
    @spiral=0 if not defined? @spiral
    @vgheight=1 if not defined? @vgheight
    @retwqe = 0 if not defined? @retwqe
    @sertewq = 0 if not defined? @sertewq
    @posledq = 0 if not defined? @posledq
    @height = 0.cm if not defined? @height
    @stylus = "Right" if not defined? @stylus 
    
    d_gstyles = ["Right"'|'"Left"]
    
    prompts = ["Axis-x:", "Axis-y:", "Axis-z:", "Distance:", "Quantity:", "A Spiral Corner:","Spiral:"]
    values = [@retwqe,@sertewq,@posledq,@height,@vgheight,@spiral,@stylus]
    enums = [  '', '', '', '', '', '', d_gstyles]
    results = inputbox prompts, values,enums, "Moving parametres."  
    return if not results
           @retwqe,@sertewq,@posledq,@height,@vgheight,@spiral,@stylus=results
  end
  def reset
    @pts = []
    @state = 0
    @ip1.clear
    @drawn = false
    Sketchup::set_status_text "", SB_VCB_LABEL
    Sketchup::set_status_text "", SB_VCB_VALUE
    Sketchup::set_status_text "Click to start drawing"
    @shift_down_time = Time.now
  end
def activate
    self.reset
    ss=Sketchup.active_model.selection
        if ss.empty?
    		UI.messagebox("No section.")
        Sketchup.active_model.select_tool nil
        end
end
def deactivate(view)
    view.invalidate if @drawn
end
def set_current_point(x, y, view)
    if( !@ip.pick(view, x, y, @ip1) )
        return false
    end
    need_draw = true
    view.tooltip = @ip.tooltip
    case @state
    when 0
        @pts[0] = @ip.position
        @heihre=@height
        @gasert=@sertewq
        @dertyg=@retwqe
        @gastrew=@posledq
        need_draw = @ip.display? || @drawn
    when 1
        @pts[1] = @ip.position
        @length = @pts[0].distance@pts[1]
        Sketchup::set_status_text ":  ", SB_VCB_LABEL
        Sketchup::set_status_text @length.to_s, SB_VCB_VALUE
               
              if(@height>0) then
                   @heiguf=@height
                 else
                  @heihre=@length
                   @heiguf=@length
               end
        
             if(@spiral>0) then
                  @vgheight=((@length/@heiguf)-1).to_i
                 @heihre=(@length/@vgheight).to_f
                @spiruo=@spiral
            end
        
      end
    view.invalidate if need_draw
  end
def onMouseMove(flags, x, y, view)
    self.set_current_point(x, y, view)
  end
def create_peremeshenie

  @gsret = 0
   
   if(@spiral>0&&@height ==0)
              UI.messagebox("Set distance.")
         return nil
       end
       
  ss=Sketchup.active_model.selection
 
    	sents=[]
    	ss.each{|e|sents.push(e)}
    	copy_group=Sketchup.active_model.active_entities.add_group(sents)
      new_center = copy_group.bounds.center.clone
 
    a = 0
    while a < @vgheight
    @gsret =@gsret+(@heihre/2).to_f
    a = a + 1
      new_group=copy_group.copy
    	sents=[]
    	new_group.entities.each{|e|sents.push(e)}
        x=-1
        y=-1
    @vec = Geom::Vector3d.new(@pts[0],@pts[1])
    if(@stylus=="Right") then
          @tvec = Geom::Vector3d.new([-1,0,0],[0,0,0])
          @pvec=Geom::Vector3d.new(@pts[0],@pts[1])
          @kvec = Geom::Vector3d.new([0,-1,0],[0,0,0])
          @rvec = Geom::Vector3d.new([0,0,-1],[0,0,0])
       else
          @pvec=Geom::Vector3d.new(@pts[1],@pts[0])
          @tvec = Geom::Vector3d.new([0,0,0],[-1,0,0])
          @kvec = Geom::Vector3d.new([0,0,0],[0,-1,0])
          @rvec = Geom::Vector3d.new([0,0,0],[0,0,-1])
    end
    @pt0=Geom::Point3d.new(new_center[0], new_center[1], new_center[2])
    @pt0j=@pt0.offset(@vec, @gsret)
     if(@pts[1][2]==0) then
        z=1
      t = Geom::Transformation.new(@pt0, @rvec, @posledq.degrees)
      @posledq=@posledq+@gastrew
      else
        z=-1
        t = Geom::Transformation.new(@pt0, @rvec, @posledq.degrees)
        @posledq=@posledq+@gastrew
      end
        new_group.transform!(t)
        tt = Geom::Transformation.scaling(@pt0j,x,y,z)
        new_group.transform!(tt)
        @vvec = Geom::Vector3d.new([-1,0,0],[0,0,0])
        ttt = Geom::Transformation.scaling(new_group.bounds.center,x,y,z)
        new_group.transform!(ttt)
  case
    when @retwqe >0
      tr = Geom::Transformation.new(new_group.bounds.center, @tvec, @retwqe.degrees)
      new_group.transform!(tr)
      @retwqe=@retwqe+@dertyg
    when @sertewq >0
      tk = Geom::Transformation.new(new_group.bounds.center, @kvec, @sertewq.degrees)
      new_group.transform!(tk)
      @sertewq=@sertewq+@gasert
      when @spiral >0
      tk = Geom::Transformation.new(@pts[0], @pvec, @spiral.degrees)
      new_group.transform!(tk)
      @spiral=@spiral+@spiruo
    end
  end
  if UI.messagebox("Erase original  selection?    ",MB_YESNO,"")==6
    	   Sketchup.active_model.commit_operation
    	    Sketchup.active_model.selection.clear
      	    copy_group.erase!
      	else
           Sketchup.active_model.selection.clear
           new_group.explode
           copy_group.explode
    end
        self.reset
        Sketchup.active_model.select_tool nil
    end
def increment_state
    @state += 1
    case @state
    when 1
        @ip1.copy! @ip
        Sketchup::set_status_text "Set a direction."
    when 2
        self.create_peremeshenie
    end
 end
 def onLButtonDown(flags, x, y, view)
    self.set_current_point(x, y, view)
    self.increment_state
    view.lock_inference
  end  
    def onCancel(flag, view)
        view.invalidate if @drawn
        reset
    end  
 def draw(view)
    @drawn = false
    if( @ip.valid? && @ip.display? )
        @ip.draw(view)
        @drawn = true
    end
    if( @state == 1 )
        view.set_color_from_line(@ip1, @ip)
            view.draw(GL_LINE_STRIP, @ip1.position, @ip.position)
            @drawn = true
      end
    end 
end
  #===================================================================================================================
  if( not file_loaded?("zerkalo_eng.rb") )
            UI.add_context_menu_handler do |menu|
            menu.add_separator
            menu.add_item("           MOVING, ROTATION, COPY.     ") { Sketchup.active_model.select_tool Zerkalocopy_create.new }
      end
   end
   file_loaded("zerkalo_eng.rb")